/***************************************************************************
*   Copyright (C) 2004 by Thomas Fischer                                  *
*   fischer@unix-ag.uni-kl.de                                             *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/
#include <kbibtexlistview.h>
#include <kbibtexlistviewitem.h>

#include "kbibtexfile.h"

KBibTeXFile::KBibTeXFile( QObject *parent, const char *name )
        : BibTeXFile( parent, name )
{}


KBibTeXFile::~KBibTeXFile()
{}

void KBibTeXFile::reorderElements( KBibTeXListView *lv )
{
    KBibTeXListViewItem * lvCur = dynamic_cast<KBibTeXListViewItem*>( lv->firstChild() );
    KBibTeXListViewItem * nextLvCur = NULL;

    elements.clear();
    while ( lvCur )
    {
        elements.append( lvCur->element() );
        nextLvCur = dynamic_cast<KBibTeXListViewItem*>( lvCur->firstChild() );
        if ( nextLvCur == NULL )
        {
            nextLvCur = dynamic_cast<KBibTeXListViewItem*>( lvCur->nextSibling() );
            if ( nextLvCur == NULL )
                nextLvCur = lvCur->parent() == NULL ? NULL : dynamic_cast<KBibTeXListViewItem*>( lvCur->parent() ->nextSibling() );
        }

        lvCur = nextLvCur;
    }
}

#include "kbibtexfile.moc"
